# Command line options

## Usage

    shiboken [options] header-file typesystem-file

## Options

`--disable-verbose-error-messages`
  Disable verbose error messages. Turn the CPython code hard to debug but saves a few kilobytes in the generated binding.

`--enable-parent-ctor-heuristic`
  This flag enable an useful heuristic which can save a lot of work related to object ownership when writing the typesystem. For more info, check Parentship heuristics.

`--enable-pyside-extensions`
  Enable pyside extensions like support for signal/slots. Use this if you are creating a binding based on PySide.

`--enable-return-value-heuristic`
  Enable heuristics to detect parent relationship on return values. For more info, check Return value heuristics.

`--avoid-protected-hack`
  Avoid the use of the ‘#define protected public’ hack.

`--use-isnull-as-nb_nonzero`
  If a class have an isNull() const method, it will be used to compute the value of boolean casts

`--api-version=<version>`
  Specify the supported api version used to generate the bindings.

`--documentation-only`
  Do not generate any code, just the documentation.

`--drop-type-entries="<TypeEntry0>[;TypeEntry1;...]"`
  Semicolon separated list of type system entries (classes, namespaces, global functions and enums) to be dropped from generation.

`--generation-set`
  Generator set to be used (e.g. qtdoc).

`--skip-deprecated`
  Skip deprecated functions.

`--diff`
  Print a diff of wrapper files.

`--dryrun`
  Dry run, do not generate wrapper files.

`--project-file=<file>`
  Text file containing a description of the binding project. Replaces and overrides command line arguments.

`-I<path>, --include-paths=<path>[:<path>:...]`
  Include paths used by the C++ parser.

… _system-include-paths:

`-isystem<path>, --system-include-paths=<path>[:<path>:...]`
  System include paths used by the C++ parser

`-F<path>, --framework-include-paths=<path>[:<path>:...]`
  Framework include paths used by the C++ parser

`--language-level=, -std=<level>`
  C++ Language level (c++11..c++17, default=c++14)

`-T<path>, --typesystem-paths=<path>[:<path>:...]`
  Paths used when searching for type system files.

`--output-directory=[dir]`
  The directory where the generated files will be written.

`--license-file=[license-file]`
  File used for copyright headers of generated files.

`--no-suppress-warnings`
  Show all warnings.

`--silent`
  Avoid printing any message.

`--debug-level=[sparse|medium|full]`
  Set the debug level.

`--help`
  Display this help and exit.

`--version`
  Output version information and exit.

## QtDocGenerator Options

`--doc-parser=<parser>`
  The documentation parser used to interpret the documentation input files (qdoc|doxygen).

`--documentation-code-snippets-dir=<dir>`
  Directory used to search code snippets used by the documentation.

`--documentation-data-dir=<dir>`
  Directory with XML files generated by documentation tool.

`--documentation-extra-sections-dir=<dir>`
  Directory used to search for extra documentation sections.

`--library-source-dir=<dir>`
  Directory where library source code is located.

`--additional-documentation=<file>`
  List of additional XML files to be converted to .rst files (for example, tutorials).